//---------------------------------------------------------------------------
#ifndef DepthH
#define DepthH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <ExtDlgs.hpp>
#include <Graphics.hpp>

//---------------------------------------------------------------------------
//                 0           1           2             3           4              5
enum TPlane       {TXYPlane  , TXZPlane  , TYZPlane      };
enum TSpindleDir  {TCW       , TCCW      , TStop         };
enum TCoolant     {TMist     , TFlood    , TNone         };
enum TUnits       {TMetric   , TInch       };
enum TCutterComp  {TCCNone   , TCCLeft   , TCCRight      };
enum TPathControl {TExact    , TVelocity   };
enum TAxis        {TXAxis    , TYAxis    , TZAxis      , TAAxis    , TBAxis       , TCAxis       };
enum TErrorType   {TXZPresent, TYZPresent, TZeroSizeArc, TPlaneType, TUnknownMCode, TUnknownGCode, TAAxisInstruction, TBAxisInstruction, TCAxisInstruction};

typedef struct  {
    double x, y, z;
    } nodalposition;


class TDepthCutForm : public TForm
{
__published:	// IDE-managed Components
    TLabel *Label1;
    TEdit *Edit1;
    TSaveDialog *SaveDialog1;
    TButton *OriginalBMPButton;
    TButton *NewDXFButton;
    TLabel *Label2;
    TEdit *Edit2;
    TLabel *Label6;
    TLabel *Label4;
    TEdit *Edit3;
    TLabel *Label5;
    TEdit *Edit4;
    TLabel *Label7;
    TButton *CreateDXFButton;
    TButton *HelpButton;
    TButton *CloseButton;
    TLabel *Label3;
    TLabel *Label9;
    TEdit *Edit5;
    TLabel *Label10;
    TEdit *Edit6;
    TLabel *Label11;
    TComboBox *ComboBox2;
    TEdit *Edit7;
    TLabel *Label12;
    TBevel *Bevel1;
    TOpenPictureDialog *OpenDialog1;
    TButton *CreateSTLButton;
    TButton *CreateOBJButton;
    TLabel *Label8;
    TEdit *Edit8;
    TButton *CreateNCButton;
    TLabel *Label13;
    TEdit *Edit9;
    TLabel *Label14;
    TLabel *Label15;
    TLabel *Label16;
    TEdit *Edit10;
    TEdit *Edit11;
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall FormDestroy(TObject *Sender);
    void __fastcall OriginalBMPButtonClick(TObject *Sender);
    void __fastcall NewDXFButtonClick(TObject *Sender);
    void __fastcall CreateDXFButtonClick(TObject *Sender);
    void __fastcall HelpButtonClick(TObject *Sender);
    void __fastcall CloseButtonClick(TObject *Sender);
    void __fastcall CreateSTLButtonClick(TObject *Sender);
    void __fastcall CreateOBJButtonClick(TObject *Sender);
    void __fastcall Edit6Change(TObject *Sender);
    void __fastcall CreateNCButtonClick(TObject *Sender);
    void __fastcall Edit1Change(TObject *Sender);
private:	// User declarations
    Graphics::TBitmap *Picture;
    bool ConversionPossible;
    nodalposition __fastcall UnitVector(nodalposition vector1);
    nodalposition __fastcall VectorProduct(nodalposition vector1, nodalposition vector2);
    nodalposition __fastcall SubtractVector(nodalposition Node1, nodalposition Node2);
    void __fastcall SetInterface(bool Setting);
    void __fastcall SetButtons(bool Setting);
public:		// User declarations
    __fastcall TDepthCutForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TDepthCutForm *DepthCutForm;
//---------------------------------------------------------------------------
#endif
